﻿using IceCreamShopListImplement.Models;

namespace IceCreamShopListImplement
{
    public class DataListSingleton
    {
        private static DataListSingleton? _instance;

        public List<Component> Components { get; set; }

        public List<Order> Orders { get; set; }

        public List<IceCream> IceCreams { get; set; }

        public List<Client> Clients { get; set; }

        public List<Shop> Shops { get; set; }

        private DataListSingleton()
        {
            Components = new List<Component>();
            Orders = new List<Order>();
            IceCreams = new List<IceCream>();
            Clients = new List<Client>();
            Shops = new List<Shop>();
        }

        public static DataListSingleton GetInstance()
        {
            if (_instance == null)
            {
                _instance = new DataListSingleton();
            }
            return _instance;
        }
    }
}